3c0cf02fb0473dcbcddd43983a85799180a6c360
[oweals/gnunet.git] / src / gns / test_gns_revocation.sh
1 #!/bin/sh
2 # This file is in the public domain.
3 trap "gnunet-arm -e -c test_gns_lookup.conf" SIGINT
4 which timeout > /dev/null 2>&1 && DO_TIMEOUT="timeout 5"
5
6 LOCATION=$(which gnunet-config)
7 if [ -z $LOCATION ]
8 then
9   LOCATION="gnunet-config"
10 fi
11 $LOCATION --version 1> /dev/null
12 if test $? != 0
13 then
14         echo "GNUnet command line tools cannot be found, check environmental variables PATH and GNUNET_PREFIX"
15         exit 77
16 fi
17
18 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
19 MY_EGO="myego"
20 OTHER_EGO="delegatedego"
21 TEST_IP="127.0.0.1"
22
23 gnunet-arm -s -c test_gns_lookup.conf
24 gnunet-identity -C $OTHER_EGO -c test_gns_lookup.conf
25 DELEGATED_PKEY=$(gnunet-identity -d -c test_gns_lookup.conf | grep $OTHER_EGO | awk '{print $3}')
26 gnunet-identity -C $MY_EGO -c test_gns_lookup.conf
27 gnunet-namestore -p -z $MY_EGO -a -n b -t PKEY -V $DELEGATED_PKEY -e never -c test_gns_lookup.conf
28 gnunet-namestore -p -z $OTHER_EGO -a -n www -t A -V $TEST_IP -e never -c test_gns_lookup.conf
29 RES_IP=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
30 gnunet-revocation -R $OTHER_EGO -p  -c test_gns_lookup.conf
31 RES_IP_REV=`$DO_TIMEOUT gnunet-gns --raw -u www.b.$MY_EGO -t A -c test_gns_lookup.conf`
32 gnunet-namestore -z $MY_EGO -d -n b -t PKEY -V $DELEGATED_PKEY  -e never -c test_gns_lookup.conf
33 gnunet-namestore -z $OTHER_EGO -d -n www -t A -V $TEST_IP  -e never -c test_gns_lookup.conf
34 gnunet-arm -e -c test_gns_lookup.conf
35 rm -rf `gnunet-config -c test_gns_lookup.conf -f -s paths -o GNUNET_TEST_HOME`
36
37 if [ "$RES_IP" != "$TEST_IP" ]
38 then
39   echo "Failed to resolve to proper IP, got $RES_IP."
40   exit 1
41 fi
42
43 if [ "x$RES_IP_REV" = "x" ]
44 then
45   exit 0
46 else
47   echo "Failed to revoke zone, got $RES_IP_REV."
48   exit 1
49 fi